image: alpine

stages:
  - build
  - test
  - package
  - cleanup
  - push
  - deploy

build:
  stage: build
  script: cat file1.txt file2.txt > compiled.txt
  artifacts:
    paths:
    - compiled.txt
    expire_in: 20 minutes

test:
  stage: test
  script: cat compiled.txt | grep -q 'Hello world'

package:
  stage: package
  script: cat compiled.txt | gzip > package.gz
  artifacts:
    paths:
    - packaged.gz

cleanup:
  stage: cleanup
  image:
    name: docker/compose:1.27.4
    entrypoint: [""]
  script: cat compiled.txt | gzip > package.gz
  when: always

push:
  stage: push
  before_script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
  script:
    - docker push $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:$CI_COMMIT_REF_SLUG.$CI_PIPELINE_ID
  only:
    - master

deploy:
  stage: deploy
  image: centosadmin/kubernetes-helm:3.6.3
  script:
    - kubectl config set-cluster k8s --insecure-skip-tls-verify=true --server=$K8S_API_URL
    - kubectl config set-credentials ci --token=$K8S_CI_TOKEN
    - kubectl config set-contex ci --cluster=k8s --user=ci
    - kubectl config use-contex ci
    - helm upgrade --install xpaste .helm
        --set image=$CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME
        --set imageTag=$CI_COMMIT_REF_SLUG.$CI_PIPELINE_ID
        --debug
        --namespace g000005-pipeline
        --atomic
        --timeout 180s
  only:
    - master

